<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class SmartSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct(){
        parent::__construct(self::ID);
    }
	
	public static function get_media_url_str(){
        return MediaURL::encode(array('screen_id' => self::ID));
    }
	
    public function do_get_control_defs(&$plugin_cookies){
        $defs = array();
		$epg_font = (HD::get_item('epg_font') !='') ? HD::get_item('epg_font') : PLUGIN_FONT_NORMAL;
		$start_tv = (HD::get_item('start_tv') !='') ? HD::get_item('start_tv') : 0;
		$epg_leng = (HD::get_item('epg_leng') !='') ? HD::get_item('epg_leng') : 'uk';
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';
		ControlFactory::add_label($defs, 'Версия:', HD::ver());
        $epg_font_ops[PLUGIN_FONT_NORMAL] = 'Нормальный';
        $epg_font_ops[PLUGIN_FONT_SMALL] = 'Мелкий';

		$epg_leng_ops['uk'] = 'украинский';
		$epg_leng_ops['ru'] = 'русский';

		$start_ops[0] = 'Категории и каналы';
		$start_ops[1] = 'Запускать просмотр ТВ';
		
		
		
        $this->add_combobox($defs,
            'start_tv', 
			'Старт плагина',
            $start_tv, $start_ops, 0, true
		);

		$this->add_combobox($defs, 
			'epg_leng', 
			'Язык тв программы:', 
			$epg_leng, $epg_leng_ops, 0, true
		);
		$this->add_combobox($defs, 
			'epg_font', 
			'Шрифт тв программы:', 
			$epg_font, $epg_font_ops, 0, true
		);
		$this->add_button(
            $defs,'pin_dialog',
            'Код родительского контроля:',
            'Изменить', 0
		);
		ControlFactory::add_label($defs, '___________________________', '_________________________________________');
		$jsd = SmartConfig::hlsclient();
		if ((isset($jsd->success->trashed->type))&&($jsd->success->trashed->type == 'paused'))
			ControlFactory::add_label($defs, 'Внимание:', "Услуга Приостановлена");
		else if (isset($jsd->success->set_of_channels_restriction))
			ControlFactory::add_label($defs, '', $jsd->success->set_of_channels_restriction);
		else if (isset($jsd->success->trashed->expired)){
			if ($jsd->success->trashed->type == 'big')
				$arg = 'Большое промо ';
			else if ($jsd->success->trashed->type == 'small')
				$arg = 'Малое промо ';
			else
				$arg = '';
			ControlFactory::add_label($defs, $arg . "Дней Просмотра: ",  $jsd->success->trashed->expired);
		}else if (isset($jsd->error))
			ControlFactory::add_label($defs, 'Error: ', $jsd->error_msg .' - '. $jsd->error);
		else if (isset($jsd->success->message)){
			ControlFactory::add_label($defs, '', $jsd->success->message->name);
			ControlFactory::add_label($defs, '', $jsd->success->message->phone);
			ControlFactory::add_label($defs, '', $jsd->success->message->url);
		}else
			ControlFactory::add_label($defs, '', 'Error!');
		ControlFactory::add_label($defs, "Серийный номер:", HD::get_serial_number());
		$this->add_button(
            $defs,'change_omega_key',
            'Kод доступа:',
            'Ввести', 0
		);
		ControlFactory::add_label($defs, '___________________________', '_________________________________________');
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies){
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies){
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		$omega_key = (HD::get_item('omega_key') !='') ? HD::get_item('omega_key') : false;

		if ($user_input->control_id === 'change_omega_key'){
			$defs = array();
				if ($omega_key == false)
					$omega_key = 'Введите код';
				ControlFactory::add_multiline_label($defs, '', "Код активации (получить в личном кабинете cabinet.mynet.ua)", 6);
				ControlFactory::add_text_field($defs,
					$handler=null, $add_params=null,
					'omega_key', '',
					$omega_key, 0, 0, 0, 0, 1050);
				ControlFactory::add_smart_label($defs,"", '<text dy="7" size="small"> Нажмите </text><icon>gui_skin://special_icons/controls_button_blue.aai</icon><text dy="7" size="small"> для вызова экранной клавиатуры</text>');
				$action = UserInputHandlerRegistry::create_action($this, 'omega_key');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'omega_key', 'Применить', 350, $action);
				return ActionFactory::show_dialog('Введите код доступа', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'omega_key'){
			if (($user_input->omega_key == false)&&(strlen($user_input->omega_key) != 4))
				return UserInputHandlerRegistry::create_action($this, 'change_omega_key');
			$jsd = SmartConfig::hlsclient($user_input->omega_key);
			if (!isset($jsd->success)){
				$trashed = '';	
				if (isset($jsd->trashed->type))
					$trashed = $jsd->trashed->type;				
				throw new DuneException(
					'HTTP network error', 0,
					ActionFactory::show_error(
					true,
					'Error: '. $jsd->error_msg .' - '. $jsd->error,
					array(
						$jsd->message->name,
						$jsd->message->phone,
						$trashed))
				);
			}
			$perform_new_action = ActionFactory::launch_media_url('plugin_launcher://' . DuneSystem::$properties['plugin_name']);;
			return ActionFactory::invalidate_folders(array('tv_channel_list'), $perform_new_action);
		}
		if ($user_input->control_id === 'epg_font')
			HD::save_item('epg_font', $user_input->epg_font);
		if ($user_input->control_id === 'epg_leng'){
			HD::save_item('epg_leng', $user_input->epg_leng);
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'reset_controls');
			return ActionFactory::invalidate_folders(array('tv_channel_list'), $perform_new_action);
		}
		if ($user_input->control_id === 'start_tv')
			HD::save_item('start_tv', $user_input->start_tv);
		
		if ($user_input->control_id === 'pin_dialog'){
			$defs = array();
			$this->add_text_field($defs,
				'pin1', 'Старый код родительского контроля:',
				'', 1, 1, 0, 1, 500, 0, false);
			$this->add_text_field($defs,
				'pin2', 'Новый код родительского контроля:',
				'', 1, 1, 0, 1, 500, 0, false);
			$this->add_label($defs, 'По умолчанию - 0000', '');
			$this->add_label($defs, 'Код 1111 - отключение', '');
			$this->add_close_dialog_and_apply_button($defs,'pin_apply', 'Применить', 250);					
			return  ActionFactory::show_dialog('Родительский контроль',	$defs, true);
		}
		
		if ($user_input->control_id === 'reset_controls')
			return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
		
		if ($user_input->control_id === 'pin_apply'){
			$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
			if ($user_input->pin1 == '' || $user_input->pin2 == '')
				$msg = 'Код не изменен!';
			else if ($user_input->pin1 == $pin){
				$plugin_cookies->pin = $user_input->{'pin2'};
				$msg = 'Код изменен!';
			}
			else
				$msg = 'Код не изменен!';
				return  ActionFactory::show_title_dialog($msg,$action = null);
		}
        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
